clear all;
cauchy = @(x) 1./(1+x.^2);
norm = @(x,mu,sig) 1/sig*exp(-0.5*((x-mu)/sig).^2); 
% Generate 10000 samples in the chain.
% Set up the constants.
S = 30000;
sig = 8;
x = zeros(1,S);
prob_accept=0;
x(1) = randn(1); % generate the starting point
for s = 2:S
    y = x(s-1) + sig*randn(1);
    % generate a uniform for comparison
    u = rand(1);
    alpha=min([1, cauchy(y)*norm(x(s-1),y,sig)/...
            (cauchy(x(s-1))*norm(y,x(s-1),sig))]);
%         [norm(x(i-1),y,sig) norm(y,x(i-1),sig)]
    if u <= alpha
        x(s) = y;
        prob_accept=prob_accept+1;
    else
        x(s) = x(s-1);
    end
    prob_accept/s
end
x=x(10001:end);
xx=-40:1:40;
c=cauchy(xx)./pi;
[a,b]=hist(x,xx);
figure;
hold on
bar(xx,a./length(x),0.99,'k');
plot(xx,c,'r','LineWidth',2);
title('Cauchy density','FontSize',16)
legend({'estimated','true'},'FontSize',14)
hold off
